DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Private Attributes | Friends | List of all members
DcmByteString Class Reference

base class for all DICOM value representations storing a character string More...

Inheritance diagram for DcmByteString:

## Public Member Functions
| DcmByteString (const DcmTag &tag)
| constructor. More...
| DcmByteString (const DcmByteString &old)
| copy constructor More...
virtual | ~DcmByteString ()
| destructor
DcmByteString & | operator= (const DcmByteString &obj)
| assignment operator More...
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type. More...
virtual DcmObject * | clone () const
| clone method More...
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying. More...
virtual DcmEVR | ident () const
| get element type identifier More...
virtual OFCondition | clear ()
| clear the currently stored value More...
virtual unsigned long | getVM ()
| get value multiplicity More...
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element. More...
Uint32 | getRealLength ()
| get length of the stored value. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| get DICOM length of the stored value. More...
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print element to a stream. More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream as required for the creation of digital signatures More...
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a copy of a particular string component More...
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get entire element value as a character string. More...
virtual OFCondition | getString (char *&stringVal)
| get a pointer to the current string value. More...
virtual OFCondition | getString (char *&stringVal, Uint32 &stringLen)
| get a pointer to the current string value. More...
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string. More...
virtual OFCondition | putOFStringAtPos (const OFString &stringVal, const unsigned long pos=0)
| set element value at specific VM position in the given character string. More...
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string. More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored string value. More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this element contains non-ASCII characters. More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this element is affected by SpecificCharacterSet More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
virtual OFBool | matches (const OFString &key, const OFString &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching on a single pair of string values. More...
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmElement (const DcmElement &old)
| copy constructor More...
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree. More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory More...
virtual void | transferInit ()
| initialize the transfer state of this object. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this. More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format More...
virtual OFCondition | checkValue (const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM More...
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8. More...
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16. More...
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16. More...
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32. More...
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32. More...
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32. More...
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64. More...
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64. More...
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64. More...
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey. More...
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16. More...
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16. More...
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32. More...
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32. More...
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32. More...
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64. More...
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64. More...
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64. More...
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object). More...
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value. More...
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value. More...
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value. More...
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value. More...
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value. More...
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value. More...
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value. More...
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value. More...
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value. More...
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued). More...
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued). More...
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued). More...
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued). More...
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued). More...
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued). More...
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued). More...
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value. More...
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it. More...
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it. More...
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file. More...
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again. More...
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image. More...
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object. More...
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image More...
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching. More...
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching. More...
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise. More...
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored. More...
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
virtual void | transferEnd (void)
| finalize the transfer state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object. More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet) More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Protected Types
enum | E_StringMode { DCM_MachineString , DCM_DicomString , DCM_UnknownString }
| internal type used to specify the current string representation More...

## Protected Member Functions
| DcmByteString (const DcmTag &tag, const Uint32 len)
| constructor. More...
virtual Uint8 * | newValueField ()
| create a new value field (string buffer) of the previously defined size (member variable 'Length'). More...
virtual void | postLoadValue ()
| method is called after the element value has been loaded. More...
E_StringMode | getStringMode () const
| get current representation of the string value More...
virtual OFCondition | makeMachineByteString (const Uint32 length=0)
| convert currently stored string value to internal representation. More...
OFCondition | makeDicomByteString ()
| convert currently stored string value to DICOM representation. More...
OFCondition | getStringValue (OFString &stringVal)
| get a copy of the current string value. More...
Uint32 | getMaxLength () const
| get the maximum number of characters for each string component More...
char | getPaddingChar () const
| get the end-of-string padding character More...
void | setPaddingChar (char c)
| set the end-of-string padding character More...
void | setMaxLength (Uint32 val)
| set the maximum number of characters for each string component More...
void | setNonSignificantChars (const OFString &characters)
| set non-significant characters used to determine whether the value is empty More...
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value. More...
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value. More...
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block More...
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size. More...
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this. More...
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back More...
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format More...
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format More...
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format More...
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format More...
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field More...
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field More...
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...

## Static Protected Member Functions
static OFBool | containsExtendedCharacters (const char *stringVal, const size_t stringLen)
| check if a given character string contains non-ASCII characters. More...
static OFCondition | checkStringValue (const OFString &value, const OFString &vm, const OFString &vr, const int vrID, const size_t maxLen=0, const OFString &charset="")
| check whether given string value conforms to a certain VR and VM. More...
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...

## Private Attributes
char | paddingChar
| padding character used to adjust odd value length (e.g. a space)
Uint32 | maxLength
| maximum number of characters for each string component
Uint32 | realLength
| number of characters of the internal string representation
E_StringMode | fStringMode
| current representation of the string value
OFString | nonSignificantChars
| non-significant characters used to determine whether the value is empty

## Friends
class | DcmItem

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR) More...
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR) More...
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM) More...
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string. More...
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM) More...
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

base class for all DICOM value representations storing a character string

## Member Enumeration Documentation

## ◆ E_StringMode

enum DcmByteString::E_StringMode
| protected

internal type used to specify the current string representation

Enumerator
DCM_MachineString | string has internal representation (no padding)
DCM_DicomString | string has DICOM representation (even length)
DCM_UnknownString | string has unknown representation (maybe multiple padding chars?)

## Constructor & Destructor Documentation

## ◆ DcmByteString() [1/3]

DcmByteString::DcmByteString | ( | const DcmTag & | tag | ) |

constructor.

Create new element from given tag.

Parameters

  tag | DICOM tag for the new element

## ◆ DcmByteString() [2/3]

DcmByteString::DcmByteString | ( | const DcmByteString & | old | ) |

copy constructor

Parameters

  old | element to be copied

## ◆ DcmByteString() [3/3]

DcmByteString::DcmByteString | ( | const DcmTag & | tag,
|  | const Uint32 | len
| ) |  |
| protected

constructor.

Create new element from given tag and length. Only reachable from friend classes since construction with length different from 0 leads to a state with length being set but the element's value still being uninitialized. This can lead to crashes when the value is read or written. Thus the method calling this constructor with length > 0 must ensure that the element's value is explicitly initialized, too.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

## Member Function Documentation

## ◆ checkStringValue()

static OFCondition DcmByteString::checkStringValue | ( | const OFString & | value,
|  | const OFString & | vm,
|  | const OFString & | vr,
|  | const int | vrID,
|  | const size_t | maxLen = `0`,
|  | const OFString & | charset = `""`
| ) |  |
| static protected

check whether given string value conforms to a certain VR and VM.

Parameters

  value | string value to be checked (possibly multi-valued)
  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values; "" for no check.)
  vr | two-character identifier of the VR to be checked (lower case)
  vrID | expected numeric identifier of the VR
  maxLen | maximum number of characters allowed for a single value (0 = no check)
  charset | character set (according to the value of the SpecificCharacterSet element) to be used for checking the string value. The default is ASCII (7-bit). Currently, the VR checker only supports ASCII (ISO_IR 6) and Latin-1 (ISO_IR 100). All other values disable the check of the value representation, e.g. "UNKNOWN".

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

## ◆ clear()

virtual OFCondition DcmByteString::clear | ( |  | ) |
| virtual

clear the currently stored value

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ clone()

virtual DcmObject* DcmByteString::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Implements DcmObject.

Reimplemented in DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmShortText, DcmShortString, DcmPersonName, DcmLongText, DcmLongString, DcmIntegerString, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, DcmAgeString, DcmApplicationEntity, and DcmCharString.

## ◆ compare()

virtual int DcmByteString::compare | ( | const DcmElement & | rhs | ) | const
| virtual

comparison operator that compares the normalized value of this object with a given object of the same type.

The tag of the element is also considered as the first component that is compared, followed by the object types (VR, i.e. DCMTK'S EVR) and the comparison of all value components of the object, preferably in the order declared in the object (if applicable).

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if this element has fewer components than the rhs element. Also -1 if the value of the first component that does not match is lower in this object than in rhs. Also returned if rhs cannot be casted to this object type or both objects are of different VR (i.e. the DcmEVR returned by the element's ident() call are different). 1 if either this element has more components than the rhs element, or if the first component that does not match is greater in this object than in rhs object.

Implements DcmElement.

Reimplemented in DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmShortText, and DcmLongText.

## ◆ containsExtendedCharacters() [1/2]

static OFBool DcmByteString::containsExtendedCharacters | ( | const char * | stringVal,
|  | const size_t | stringLen
| ) |  |
| static protected

check if a given character string contains non-ASCII characters.

Please note that this check is pretty simple and only works for single-byte character sets that do include the 7-bit ASCII codes, e.g. for the ISO 8859 family. In other words: All character codes below 128 are considered to be ASCII codes and all others are considered to be non-ASCII.

Parameters

  stringVal | character string to be checked
  stringLen | length of the string (number of characters without the trailing NULL byte)

Returns
  true if character string contains non-ASCII characters, false otherwise

## ◆ containsExtendedCharacters() [2/2]

virtual OFBool DcmByteString::containsExtendedCharacters | ( | const OFBool | checkAllStrings = `OFFalse` | ) |
| virtual

check if this element contains non-ASCII characters.

Please note that this check is pretty simple and only works for single-byte character sets that do include the 7-bit ASCII codes, e.g. for the ISO 8859 family. In other words: All character codes below 128 are considered to be ASCII codes and all others are considered to be non-ASCII.

Parameters

  checkAllStrings | if true, also check elements with string values not affected by SpecificCharacterSet (0008,0005). By default, only check PN, LO, LT, SH, ST, UC and UT, i.e. none of the derived VR classes.

Returns
  true if element contains non-ASCII characters, false otherwise

Reimplemented from DcmObject.

Reimplemented in DcmCharString.

## ◆ copyFrom()

virtual OFCondition DcmByteString::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmElement.

Reimplemented in DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmShortText, DcmShortString, DcmPersonName, DcmLongText, DcmLongString, DcmIntegerString, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, DcmAgeString, DcmApplicationEntity, and DcmCharString.

## ◆ getLength()

virtual Uint32 DcmByteString::getLength | ( | const E_TransferSyntax | xfer = `EXS_LittleEndianImplicit`,
|  | const E_EncodingType | enctype = `EET_UndefinedLength`
| ) |  |
| virtual

get DICOM length of the stored value.

The string value is padded if required. Therefore, the returned length always has an even value.

Parameters

  xfer | not used
  enctype | not used

Returns
  number of characters stored in DICOM representation

Reimplemented from DcmElement.

## ◆ getMaxLength()

Uint32 DcmByteString::getMaxLength | ( |  | ) | const
| inline protected

get the maximum number of characters for each string component

Returns
  maximum number of characters for each string component

## ◆ getNumberOfValues()

virtual unsigned long DcmByteString::getNumberOfValues | ( |  | ) |
| virtual

get number of values stored in this element.

The result is the same as getVM() unless overwritten in a derived class.

Returns
  number of values in this element

Implements DcmObject.

## ◆ getOFString()

virtual OFCondition DcmByteString::getOFString | ( | OFString & | stringVal,
|  | const unsigned long | pos,
|  | OFBool | normalize = `OFTrue`
| ) |  |
| virtual

get a copy of a particular string component

Parameters

  stringVal | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | not used since string normalization depends on value representation

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmTime, DcmDateTime, DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmShortText, DcmShortString, DcmPersonName, DcmLongText, DcmLongString, DcmIntegerString, DcmDecimalString, DcmDate, DcmCodeString, and DcmApplicationEntity.

## ◆ getOFStringArray()

virtual OFCondition DcmByteString::getOFStringArray | ( | OFString & | stringVal,
|  | OFBool | normalize = `OFTrue`
| ) |  |
| virtual

get entire element value as a character string.

In case of VM > 1 the individual values are separated by a backslash ('\').

Parameters

  stringVal | variable in which the result value is stored
  normalize | normalize each element value prior to concatenation

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmShortText, and DcmLongText.

## ◆ getPaddingChar()

char DcmByteString::getPaddingChar | ( |  | ) | const
| inline protected

get the end-of-string padding character

Returns
  end-of-string padding character

## ◆ getRealLength()

Uint32 DcmByteString::getRealLength | ( |  | ) |

get length of the stored value.

Trailing spaces (padding characters) are ignored for the "real" length.

Returns
  number of characters stored for the string value

## ◆ getString() [1/2]

virtual OFCondition DcmByteString::getString | ( | char *& | stringVal | ) |
| virtual

get a pointer to the current string value.

This includes all string components and separators. NB: This method does not copy the stored value.

Parameters

  stringVal | reference to the pointer variable

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getString() [2/2]

virtual OFCondition DcmByteString::getString | ( | char *& | stringVal,
|  | Uint32 & | stringLen
| ) |  |
| virtual

get a pointer to the current string value.

This includes all string components and separators. Since the length is returned separately, the string value can contain more than one NULL byte. NB: This method does not copy the stored value.

Parameters

  stringVal | reference to the pointer variable
  stringLen | length of the string (number of characters without the trailing NULL byte)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ getStringMode()

E_StringMode DcmByteString::getStringMode | ( |  | ) | const
| inline protected

get current representation of the string value

Returns
  current representation of the string value

## ◆ getStringValue()

OFCondition DcmByteString::getStringValue | ( | OFString & | stringVal | ) |
| protected

get a copy of the current string value.

This includes all string components and separators.

Parameters

  stringVal | variable in which the result is stored

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getVM()

virtual unsigned long DcmByteString::getVM | ( |  | ) |
| virtual

get value multiplicity

Returns
  number of string components (separated by a backslash)

Implements DcmObject.

Reimplemented in DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmShortText, and DcmLongText.

## ◆ ident()

virtual DcmEVR DcmByteString::ident | ( |  | ) | const
| virtual

get element type identifier

Returns
  type identifier of this class (EVR_UNKNOWN)

Implements DcmObject.

Reimplemented in DcmAgeString, DcmUnlimitedText, DcmUniversalResourceIdentifierOrLocator, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmShortText, DcmShortString, DcmPersonName, DcmLongText, DcmLongString, DcmIntegerString, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, and DcmApplicationEntity.

## ◆ isAffectedBySpecificCharacterSet()

virtual OFBool DcmByteString::isAffectedBySpecificCharacterSet | ( |  | ) | const
| virtual

check if this element is affected by SpecificCharacterSet

Returns
  always returns false since none of the derived VR classes is affected by the SpecificCharacterSet (0008,0005) element

Reimplemented from DcmObject.

Reimplemented in DcmCharString.

## ◆ isEmpty()

virtual OFBool DcmByteString::isEmpty | ( | const OFBool | normalize = `OFTrue` | ) |
| virtual

check if this object is empty

Parameters

  normalize | normalize value before checking (ignore non-significant characters)

Returns
  true if object is empty, i.e. has no value, false otherwise

Reimplemented from DcmObject.

## ◆ makeDicomByteString()

OFCondition DcmByteString::makeDicomByteString | ( |  | ) |
| protected

convert currently stored string value to DICOM representation.

It removes trailing spaces apart from a possibly required single padding character (in case of odd string length).

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ makeMachineByteString()

virtual OFCondition DcmByteString::makeMachineByteString | ( | const Uint32 | length = `0` | ) |
| protected virtual

convert currently stored string value to internal representation.

It removes any trailing space character and recomputes the string length.

Parameters

  length | number of characters of the string value (optional)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented in DcmUniqueIdentifier.

## ◆ matches() [1/2]

virtual OFBool DcmByteString::matches | ( | const DcmElement & | candidate,
|  | const OFBool | enableWildCardMatching = `OFTrue`
| ) |  | const
| virtual

perform attribute matching.

Perform attribute matching on a candidate element using this element as the matching key.

Note
  The given candidate element must refer to the same attribute kind, i.e. have the same tag and VR. The method will return OFFalse if it doesn't.

Parameters

  candidate | the candidate element to compare this element with.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate matches this element, OFFalse otherwise.

Reimplemented from DcmElement.

## ◆ matches() [2/2]

virtual OFBool DcmByteString::matches | ( | const OFString & | key,
|  | const OFString & | candidate,
|  | const OFBool | enableWildCardMatching = `OFTrue`
| ) |  | const
| virtual

perform attribute matching on a single pair of string values.

Compare two single string values using the attribute matching function appropriate for this element's VR (Universal Matching, Single Value Matching, Wild Card Matching or Range Matching).

Note
  This method is called by the other overload of matches() for each combination of values in the key and candidate element (implementing multi value matching for elements with VM>1).

Parameters

  key | the key value to match against the candidate.
  candidate | the candidate value to match the key against.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate string matches the key string, OFFalse otherwise.

Reimplemented in DcmUniversalResourceIdentifierOrLocator, DcmTime, DcmDateTime, DcmDate, DcmCodeString, DcmApplicationEntity, and DcmCharString.

## ◆ newValueField()

virtual Uint8* DcmByteString::newValueField | ( |  | ) |
| protected virtual

create a new value field (string buffer) of the previously defined size (member variable 'Length').

Also handles odd value length by allocating extra space for the padding character. This method is used by derived classes only.

Returns
  pointer to the newly created value field

Reimplemented from DcmElement.

## ◆ operator=()

DcmByteString& DcmByteString::operator= | ( | const DcmByteString & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

## ◆ postLoadValue()

virtual void DcmByteString::postLoadValue | ( |  | ) |
| protected virtual

method is called after the element value has been loaded.

Can be used to correct the value before it is used for the first time.

Reimplemented from DcmElement.

## ◆ print()

virtual void DcmByteString::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`,
|  | const int | level = `0`,
|  | const char * | pixelFileName = `NULL`,
|  | size_t * | pixelCounter = `NULL`
| ) |  |
| virtual

print element to a stream.

The output format of the value is a backslash separated sequence of string components (if any).

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used
  pixelCounter | not used

Implements DcmObject.

Reimplemented in DcmUniqueIdentifier.

## ◆ putOFStringAtPos()

virtual OFCondition DcmByteString::putOFStringAtPos | ( | const OFString & | stringVal,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

set element value at specific VM position in the given character string.

Parameters

  stringVal | input character string (possibly multi-valued)
  pos | position (0..vm) where the value should be inserted

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ putString() [1/2]

virtual OFCondition DcmByteString::putString | ( | const char * | stringVal | ) |
| virtual

set element value from the given character string.

The length of the given string is determined automatically by searching for the first NULL byte.

Parameters

  stringVal | input character string (possibly multi-valued)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmUniqueIdentifier.

## ◆ putString() [2/2]

virtual OFCondition DcmByteString::putString | ( | const char * | stringVal,
|  | const Uint32 | stringLen
| ) |  |
| virtual

set element value from the given character string.

The length of the string has to be specified explicitly. The string can, therefore, also contain more than one NULL byte.

Parameters

  stringVal | input character string (possibly multi-valued)
  stringLen | length of the string (number of characters without the trailing NULL byte)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmUniqueIdentifier.

## ◆ setMaxLength()

void DcmByteString::setMaxLength | ( | Uint32 | val | ) |
| inline protected

set the maximum number of characters for each string component

Parameters

  val | maximum number of characters for each string component

## ◆ setNonSignificantChars()

void DcmByteString::setNonSignificantChars | ( | const OFString & | characters | ) |
| inline protected

set non-significant characters used to determine whether the value is empty

Parameters

  characters | non-significant characters used to determine whether the value is empty

## ◆ setPaddingChar()

void DcmByteString::setPaddingChar | ( | char | c | ) |
| inline protected

set the end-of-string padding character

Parameters

  c | end-of-string padding character

## ◆ verify()

virtual OFCondition DcmByteString::verify | ( | const OFBool | autocorrect = `OFFalse` | ) |
| virtual

check the currently stored string value.

Checks every string component for the maximum length specified for the particular value representation.

Parameters

  autocorrect | correct value and value component length if OFTrue

Returns
  status, EC_Normal if value length is correct, an error code otherwise

Implements DcmObject.

Reimplemented in DcmCharString.

## ◆ write()

virtual OFCondition DcmByteString::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

write data element to a stream

Parameters

  outStream | output stream
  oxfer | transfer syntax used to write the data
  enctype | flag, specifying the encoding with undefined or explicit length
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ writeJson()

virtual OFCondition DcmByteString::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format
| ) |  |
| virtual

write object in JSON format

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmShortString, DcmPersonName, DcmLongString, DcmIntegerString, DcmDecimalString, and DcmCharString.

## ◆ writeSignatureFormat()

virtual OFCondition DcmByteString::writeSignatureFormat | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

write data element to a stream as required for the creation of digital signatures

Parameters

  outStream | output stream
  oxfer | transfer syntax used to write the data
  enctype | flag, specifying the encoding with undefined or explicit length
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcbytstr.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1